Index: trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/ClientGroupAdapter.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/ClientGroupAdapter.cs	(revision 994)
+++ trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/ClientGroupAdapter.cs	(revision 995)
@@ -31,16 +31,15 @@
 
 namespace HeuristicLab.Hive.Server.ADODataAccess {
-  class ClientGroupAdapter : DataAdapterBase, IClientGroupAdapter {
-    private dsHiveServerTableAdapters.ClientGroupTableAdapter adapter =
-        new dsHiveServerTableAdapters.ClientGroupTableAdapter();
-
-    private dsHiveServer.ClientGroupDataTable data =
-      new dsHiveServer.ClientGroupDataTable();
+  class ClientGroupAdapter : 
+    DataAdapterBase<dsHiveServerTableAdapters.ClientGroupTableAdapter, 
+    ClientGroup, 
+    dsHiveServer.ClientGroupRow>, 
+    IClientGroupAdapter {
+    #region Fields
+    dsHiveServer.ClientGroupDataTable data =
+        new dsHiveServer.ClientGroupDataTable();
 
     private dsHiveServerTableAdapters.ClientGroup_ResourceTableAdapter resourceClientGroupAdapter =
       new dsHiveServerTableAdapters.ClientGroup_ResourceTableAdapter();
-
-    private dsHiveServer.ClientGroup_ResourceDataTable resourceClientGroupData =
-      new dsHiveServer.ClientGroup_ResourceDataTable();
 
     private IResourceAdapter resourceAdapter = null;
@@ -65,28 +64,17 @@
       }
     }
-
-    public ClientGroupAdapter() {
-      adapter.Fill(data);
-      resourceClientGroupAdapter.Fill(resourceClientGroupData);
-    }
-
-    protected override void Update() {
-      this.adapter.Update(this.data);
-      this.resourceClientGroupAdapter.Update(resourceClientGroupData);
-    }
-
-    private ClientGroup Convert(dsHiveServer.ClientGroupRow row,
+    #endregion
+
+    #region Overrides
+    protected override ClientGroup Convert(dsHiveServer.ClientGroupRow row,
       ClientGroup clientGroup) {
       if (row != null && clientGroup != null) {
         /*Parent - Permission Owner*/
-        clientGroup.ResourceId = row.ResourceId;
-        ResAdapter.GetResourceById(clientGroup);
+        clientGroup.Id = row.ResourceId;
+        ResAdapter.GetById(clientGroup);
 
         //first check for created references
-        IEnumerable<dsHiveServer.ClientGroup_ResourceRow> clientGroupRows =
-          from resource in
-            resourceClientGroupData.AsEnumerable<dsHiveServer.ClientGroup_ResourceRow>()
-          where resource.ClientGroupId == clientGroup.ResourceId
-          select resource;
+        dsHiveServer.ClientGroup_ResourceDataTable clientGroupRows =
+            resourceClientGroupAdapter.GetDataByClientGroupId(clientGroup.Id);
 
         foreach (dsHiveServer.ClientGroup_ResourceRow resourceClientGroupRow in
@@ -97,5 +85,5 @@
             from p in
               clientGroup.Resources
-            where p.ResourceId == resourceClientGroupRow.ResourceId
+            where p.Id == resourceClientGroupRow.ResourceId
             select p;
           if (resources.Count<Resource>() == 1)
@@ -104,10 +92,10 @@
           if (resource == null) {
             Resource res =
-              ClientAdapter.GetClientById(resourceClientGroupRow.ResourceId);
+              ClientAdapter.GetById(resourceClientGroupRow.ResourceId);
 
             if (res == null) {
               //is a client group
               res =
-                GetClientGroupById(resourceClientGroupRow.ResourceId);
+                GetById(resourceClientGroupRow.ResourceId);
             }
 
@@ -122,10 +110,10 @@
 
         foreach (Resource resource in clientGroup.Resources) {
-          dsHiveServer.ClientGroup_ResourceRow permOwnerUserGroupRow =
-            resourceClientGroupData.FindByClientGroupIdResourceId(
-              clientGroup.ResourceId,
-              resource.ResourceId);
-
-          if (permOwnerUserGroupRow == null) {
+          dsHiveServer.ClientGroup_ResourceDataTable found =
+            resourceClientGroupAdapter.GetDataByClientGroupResourceId(
+            clientGroup.Id,
+            resource.Id);
+
+          if (found.Count != 1) {
             deleted.Add(resource);
           }
@@ -141,8 +129,8 @@
     }
 
-    private dsHiveServer.ClientGroupRow Convert(ClientGroup clientGroup,
+    protected override dsHiveServer.ClientGroupRow Convert(ClientGroup clientGroup,
       dsHiveServer.ClientGroupRow row) {
       if (clientGroup != null && row != null) {
-        row.ResourceId = clientGroup.ResourceId;
+        row.ResourceId = clientGroup.Id;
 
         //update references
@@ -150,25 +138,31 @@
           //first update the member to make sure it exists in the DB
           if (resource is ClientInfo) {
-            ClientAdapter.UpdateClient(resource as ClientInfo);
+            ClientAdapter.Update(resource as ClientInfo);
           } else if (resource is ClientGroup) {
-            UpdateClientGroup(resource as ClientGroup);
+            Update(resource as ClientGroup);
           }
 
           //secondly check for created references
           dsHiveServer.ClientGroup_ResourceRow resourceClientGroupRow =
-            resourceClientGroupData.FindByClientGroupIdResourceId(
-                            clientGroup.ResourceId,
-                            resource.ResourceId);
+            null;
+          dsHiveServer.ClientGroup_ResourceDataTable found =
+            resourceClientGroupAdapter.GetDataByClientGroupResourceId(
+              clientGroup.Id,
+              resource.Id);
+          if (found.Count == 1)
+            resourceClientGroupRow = found[0];
 
           if (resourceClientGroupRow == null) {
             resourceClientGroupRow =
-              resourceClientGroupData.NewClientGroup_ResourceRow();
+              found.NewClientGroup_ResourceRow();
 
             resourceClientGroupRow.ResourceId =
-              resource.ResourceId;
+              resource.Id;
             resourceClientGroupRow.ClientGroupId =
-              clientGroup.ResourceId;
-
-            resourceClientGroupData.AddClientGroup_ResourceRow(
+              clientGroup.Id;
+
+            found.AddClientGroup_ResourceRow(resourceClientGroupRow);
+
+            resourceClientGroupAdapter.Update(
               resourceClientGroupRow);
           }
@@ -176,9 +170,6 @@
 
         //thirdly check for deleted references
-        IEnumerable<dsHiveServer.ClientGroup_ResourceRow> clientGroupRows =
-          from permOwner in
-            resourceClientGroupData.AsEnumerable<dsHiveServer.ClientGroup_ResourceRow>()
-          where permOwner.ClientGroupId == clientGroup.ResourceId
-          select permOwner;
+        dsHiveServer.ClientGroup_ResourceDataTable clientGroupRows =
+          resourceClientGroupAdapter.GetDataByClientGroupId(clientGroup.Id);
 
         ICollection<dsHiveServer.ClientGroup_ResourceRow> deleted =
@@ -192,5 +183,5 @@
             from r in
               clientGroup.Resources
-            where r.ResourceId == resourceClientGroupRow.ResourceId
+            where r.Id == resourceClientGroupRow.ResourceId
             select r;
 
@@ -203,81 +194,62 @@
         }
 
-        foreach (dsHiveServer.ClientGroup_ResourceRow resoruceClientGroupRow in
-          deleted) {
-          resourceClientGroupData.RemoveClientGroup_ResourceRow(
-            resoruceClientGroupRow);
-        }
-
+        foreach (dsHiveServer.ClientGroup_ResourceRow resourceClientGroupRow in deleted) {
+          resourceClientGroupRow.Delete();
+          resourceClientGroupAdapter.Update(resourceClientGroupRow);
+        }
       }
 
       return row;
     }
+
+    protected override dsHiveServer.ClientGroupRow
+      InsertNewRow(ClientGroup group) {
+      dsHiveServer.ClientGroupRow row =
+        data.NewClientGroupRow();
+
+      row.ResourceId = group.Id;
+
+      data.AddClientGroupRow(row);
+      adapter.Update(row);
+
+      return row;
+    }
+
+    protected override void
+      UpdateRow(dsHiveServer.ClientGroupRow row) {
+      adapter.Update(row);
+    }
+
+    protected override IEnumerable<dsHiveServer.ClientGroupRow>
+      FindById(long id) {
+      return adapter.GetDataById(id);
+    }
+
+    protected override IEnumerable<dsHiveServer.ClientGroupRow>
+      FindAll() {
+      return adapter.GetData();
+    }
+    #endregion
 
     #region IClientGroupAdapter Members
     [MethodImpl(MethodImplOptions.Synchronized)]
-    public void UpdateClientGroup(ClientGroup group) {
+    public override void Update(ClientGroup group) {
       if (group != null) {
-        ResAdapter.UpdateResource(group);
-
-        dsHiveServer.ClientGroupRow row =
-          data.FindByResourceId(group.ResourceId);
-
-        if (row == null) {
-          row = data.NewClientGroupRow();
-          row.ResourceId = group.ResourceId;
-          data.AddClientGroupRow(row);
-        }
-
-        Convert(group, row);
-      }
-    }
-
-    public ClientGroup GetClientGroupById(long clientGroupId) {
-      ClientGroup clientGroup = new ClientGroup();
-
-      dsHiveServer.ClientGroupRow row =
-        data.FindByResourceId(clientGroupId);
-
-      if (row != null) {
-        Convert(row, clientGroup);
-
-        return clientGroup;
-      } else {
-        return null;
-      }
-    }
-
-    public ClientGroup GetClientGroupByName(string name) {
+        ResAdapter.Update(group);
+
+        base.Update(group);
+      }
+    }
+
+    public ClientGroup GetByName(string name) {
       ClientGroup group = new ClientGroup();
-
       Resource res =
-        ResAdapter.GetResourceByName(name);
+        ResAdapter.GetByName(name);
 
       if (res != null) {
-        dsHiveServer.ClientGroupRow row =
-          data.FindByResourceId(res.ResourceId);
-
-        if (row != null) {
-          Convert(row, group);
-
-          return group;
-        }
+        return GetById(res.Id);
       }
 
       return null;
-    }
-
-    public ICollection<ClientGroup> GetAllClientGroups() {
-      ICollection<ClientGroup> allClientGroups =
-        new List<ClientGroup>();
-
-      foreach (dsHiveServer.ClientGroupRow row in data) {
-        ClientGroup clientGroup = new ClientGroup();
-
-        Convert(row, clientGroup);
-        allClientGroups.Add(clientGroup);
-      }
-
-      return allClientGroups;
     }
 
@@ -288,13 +260,10 @@
       if (resource != null) {
         IEnumerable<dsHiveServer.ClientGroup_ResourceRow> clientGroupRows =
-         from clientGroup in
-           resourceClientGroupData.AsEnumerable<dsHiveServer.ClientGroup_ResourceRow>()
-         where clientGroup.ResourceId == resource.ResourceId
-         select clientGroup;
+         resourceClientGroupAdapter.GetDataByResourceId(resource.Id);
 
         foreach (dsHiveServer.ClientGroup_ResourceRow clientGroupRow in
           clientGroupRows) {
           ClientGroup clientGroup =
-            GetClientGroupById(clientGroupRow.ClientGroupId);
+            GetById(clientGroupRow.ClientGroupId);
           clientGroups.Add(clientGroup);
         }
@@ -305,32 +274,8 @@
 
     [MethodImpl(MethodImplOptions.Synchronized)]
-    public bool DeleteClientGroup(ClientGroup group) {
+    public override bool Delete(ClientGroup group) {
       if (group != null) {
-        dsHiveServer.ClientGroupRow row =
-          data.FindByResourceId(group.ResourceId);
-
-        if (row != null) {
-          ICollection<dsHiveServer.ClientGroup_ResourceRow> deleted =
-            new List<dsHiveServer.ClientGroup_ResourceRow>();
-
-          foreach (dsHiveServer.ClientGroup_ResourceRow resourceClientGroupRow in
-            resourceClientGroupData) {
-            if (resourceClientGroupRow.ClientGroupId == group.ResourceId ||
-              resourceClientGroupRow.ResourceId == group.ResourceId) {
-              deleted.Add(resourceClientGroupRow);
-            }
-          }
-
-          foreach (dsHiveServer.ClientGroup_ResourceRow resourceClientGroupRow in
-            deleted) {
-            resourceClientGroupData.RemoveClientGroup_ResourceRow(
-              resourceClientGroupRow);
-          }
-
-          row.Delete();
-          adapter.Update(row);
-
-          return ResAdapter.DeleteResource(group);
-        }
+        return base.Delete(group) && 
+          ResAdapter.Delete(group);
       }
 
Index: trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/DataAdapterBase.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/DataAdapterBase.cs	(revision 994)
+++ trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/DataAdapterBase.cs	(revision 995)
@@ -1,18 +1,145 @@
-﻿using System;
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
 using System.Collections.Generic;
 using System.Linq;
 using System.Text;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+using System.Runtime.CompilerServices;
 
 namespace HeuristicLab.Hive.Server.ADODataAccess {
-  abstract class DataAdapterBase {
-    protected abstract void Update();
+  abstract class DataAdapterBase<AdapterT, ObjT, RowT>
+    where AdapterT: new() 
+    where RowT: System.Data.DataRow
+    where ObjT: IHiveObject, new() {
+    protected AdapterT adapter =
+      new AdapterT();
 
-    protected DataAdapterBase() {
-      ServiceLocator.GetTransactionManager().OnUpdate += 
-        new EventHandler(DataAdapterBase_OnUpdate);
+    #region Abstract methods
+    protected abstract RowT Convert(ObjT obj, RowT row);
+
+    protected abstract ObjT Convert(RowT row, ObjT obj);
+
+    protected abstract RowT InsertNewRow(ObjT obj);
+
+    protected abstract void UpdateRow(RowT row);
+
+    protected abstract IEnumerable<RowT> FindById(long id);
+
+    protected abstract IEnumerable<RowT> FindAll();
+    #endregion
+
+    protected delegate IEnumerable<RowT> Selector();
+
+    protected virtual RowT FindSingleRow(Selector selector) {
+      RowT row = default(RowT);
+
+      IEnumerable<RowT> found =
+        selector();
+
+      if (found.Count<RowT>() == 1)
+        row = found.First<RowT>();
+
+      return row;
     }
 
-    void DataAdapterBase_OnUpdate(object sender, EventArgs e) {
-      this.Update();
+    protected virtual ObjT FindSingle(Selector selector) {
+      RowT row = FindSingleRow(selector);
+
+      if (row != null) {
+        ObjT obj = new ObjT();
+        Convert(row, obj);
+
+        return obj;
+      } else {
+        return default(ObjT);
+      }
+    }
+
+    protected virtual ICollection<ObjT> FindMultiple(Selector selector) {
+      IEnumerable<RowT> found =
+        selector();
+
+      IList<ObjT> result =
+        new List<ObjT>();
+
+      foreach (RowT row in found) {
+        ObjT obj = new ObjT();
+        Convert(row, obj);
+        result.Add(obj);
+      }
+
+      return result;
+    }
+
+    protected virtual RowT GetRowById(long id) {
+      return FindSingleRow(
+        delegate() {
+          return FindById(id);
+        });
+    }
+
+    [MethodImpl(MethodImplOptions.Synchronized)]
+    public virtual void Update(ObjT obj) {
+      if (obj != null) {
+        RowT row =
+          GetRowById(obj.Id);
+
+        if (row == null) {
+          row = InsertNewRow(obj);
+        }
+
+        Convert(obj, row);
+
+        UpdateRow(row);
+
+        obj.Id = (long)row[row.Table.PrimaryKey[0]];
+      }
+    }
+
+    public virtual ObjT GetById(long id) {
+      return FindSingle(delegate() {
+        return FindById(id);
+      });
+    }
+
+    public virtual ICollection<ObjT> GetAll() {
+      return new List<ObjT>(
+        FindMultiple(
+          new Selector(FindAll)));
+    }
+
+    [MethodImpl(MethodImplOptions.Synchronized)]
+    public virtual bool Delete(ObjT obj) {
+      if (obj != null) {
+        RowT row =
+          GetRowById(obj.Id);
+
+        if (row != null) {
+          row.Delete();
+          UpdateRow(row);
+        }
+      }
+
+      return false;
     }
   }
Index: trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/HeuristicLab.Hive.Server.ADODataAccess.csproj
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/HeuristicLab.Hive.Server.ADODataAccess.csproj	(revision 994)
+++ trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/HeuristicLab.Hive.Server.ADODataAccess.csproj	(revision 995)
@@ -64,4 +64,5 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="CachedDataAdapter.cs" />
     <Compile Include="ClientAdapter.cs" />
     <Compile Include="ClientGroupAdapter.cs" />
@@ -77,4 +78,5 @@
     </Compile>
     <Compile Include="HiveServerADODataAccessPlugin.cs" />
+    <Compile Include="ICachedDataAdapter.cs" />
     <Compile Include="JobAdapter.cs" />
     <Compile Include="PermissionOwnerAdapter.cs" />
Index: trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/ICachedDataAdapter.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/ICachedDataAdapter.cs	(revision 995)
+++ trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/ICachedDataAdapter.cs	(revision 995)
@@ -0,0 +1,31 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+
+namespace HeuristicLab.Hive.Server.ADODataAccess {
+  internal interface ICachedDataAdapter {
+    void SyncWithDb();
+  }
+}
Index: trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/JobAdapter.cs
===================================================================
--- trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/JobAdapter.cs	(revision 994)
+++ trunk/sources/HeuristicLab.Hive.Server.ADODataAccess/JobAdapter.cs	(revision 995)
@@ -30,10 +30,13 @@
 
 namespace HeuristicLab.Hive.Server.ADODataAccess {
-  class JobAdapter : DataAdapterBase, IJobAdapter {
-    private dsHiveServerTableAdapters.JobTableAdapter adapter =
-        new dsHiveServerTableAdapters.JobTableAdapter();
-
-    private dsHiveServer.JobDataTable data =
-      new dsHiveServer.JobDataTable();
+  class JobAdapter :
+    CachedDataAdapter<dsHiveServerTableAdapters.JobTableAdapter,
+                      Job, 
+                      dsHiveServer.JobRow, 
+                      dsHiveServer.JobDataTable>, 
+    IJobAdapter {
+    #region Fields
+    dsHiveServer.JobDataTable data =
+        new dsHiveServer.JobDataTable();
 
     private IClientAdapter clientAdapter = null;
@@ -59,25 +62,19 @@
       }
     }
-
-    public JobAdapter() {
-      adapter.Fill(data);
-    }
-
-    protected override void Update() {
-      this.adapter.Update(this.data);
-    }
-
-    private Job Convert(dsHiveServer.JobRow row,
+    #endregion
+
+    #region Overrides
+    protected override Job Convert(dsHiveServer.JobRow row,
       Job job) {
       if (row != null && job != null) {
-        job.JobId = row.JobId;
+        job.Id = row.JobId;
 
         if (!row.IsParentJobIdNull())
-          job.ParentJob = GetJobById(row.ParentJobId);
+          job.ParentJob = GetById(row.ParentJobId);
         else
           job.ParentJob = null;
 
         if (!row.IsResourceIdNull())
-          job.Client = ClientAdapter.GetClientById(row.ResourceId);
+          job.Client = ClientAdapter.GetById(row.ResourceId);
         else
           job.Client = null;
@@ -86,5 +83,5 @@
           job.State = (State)Enum.Parse(job.State.GetType(), row.Status);
         else
-          job.State = State.idle;
+          job.State = State.nullState;
 
         return job;
@@ -93,20 +90,23 @@
     }
 
-    private dsHiveServer.JobRow Convert(Job job,
+    protected override dsHiveServer.JobRow Convert(Job job,
       dsHiveServer.JobRow row) {
       if (job != null && row != null) {
         if (job.Client != null) {
-          ClientAdapter.UpdateClient(job.Client);
-          row.ResourceId = job.Client.ResourceId;
+          ClientAdapter.Update(job.Client);
+          row.ResourceId = job.Client.Id;
         } else
           row.SetResourceIdNull();
 
         if (job.ParentJob != null) {
-          UpdateJob(job.ParentJob);
-          row.ParentJobId = job.ParentJob.JobId;
+          Update(job.ParentJob);
+          row.ParentJobId = job.ParentJob.Id;
         } else
           row.SetParentJobIdNull();
 
-        row.Status = job.State.ToString();
+        if (job.State != State.nullState)
+          row.Status = job.State.ToString();
+        else
+          row.SetStatusNull();
       }
 
@@ -114,72 +114,75 @@
     }
 
+    protected override void UpdateRow(dsHiveServer.JobRow row) {
+      adapter.Update(row);
+    }
+
+    protected override dsHiveServer.JobRow 
+      InsertNewRow(Job job) {      
+      dsHiveServer.JobRow row = data.NewJobRow();
+      data.AddJobRow(row);
+
+      return row;
+    }
+
+    protected override dsHiveServer.JobRow 
+      InsertNewRowInCache(Job job) {
+      dsHiveServer.JobRow row = cache.NewJobRow();
+      cache.AddJobRow(row);
+
+      return row;
+    }
+
+    protected override void FillCache() {
+      adapter.FillByActive(cache);
+    }
+
+    public override void SyncWithDb() {
+      this.adapter.Update(this.cache);
+    }
+
+    protected override bool PutInCache(Job job) {
+      return job != null
+        && job.State != State.offline 
+        && job.State != State.nullState;
+    }
+
+    protected override IEnumerable<dsHiveServer.JobRow>
+      FindById(long id) {
+      return adapter.GetDataById(id);
+    }
+
+    protected override dsHiveServer.JobRow
+      FindCachedById(long id) {
+      return cache.FindByJobId(id);
+    }
+
+    protected override IEnumerable<dsHiveServer.JobRow>
+      FindAll() {
+      return FindMultipleRows(
+        new Selector(adapter.GetData),
+        new Selector(cache.AsEnumerable<dsHiveServer.JobRow>));
+    }
+
+    #endregion
+
     #region IJobAdapter Members
-    [MethodImpl(MethodImplOptions.Synchronized)]
-    public void UpdateJob(Job job) {
+    public ICollection<Job> GetAllSubjobs(Job job) {
       if (job != null) {
-        dsHiveServer.JobRow row =
-          data.FindByJobId(job.JobId);
-
-        if (row == null) {
-          row = data.NewJobRow();
-          data.AddJobRow(row);
-
-          //write row to db to get primary key
-          adapter.Update(row);
-        }
-
-        Convert(job, row);
-        job.JobId = row.JobId;
-      }
-    }
-
-    public Job GetJobById(long id) {
-      dsHiveServer.JobRow row =
-        data.FindByJobId(id);
-
-      if (row != null) {
-        Job job = new Job();
-        
-        Convert(row, job);
-
-        return job;
+        return
+          base.FindMultiple(
+            delegate() {
+              return adapter.GetDataBySubjobs(job.Id);
+            },
+            delegate() {
+              return from j in
+                   cache.AsEnumerable<dsHiveServer.JobRow>()
+                 where  !j.IsParentJobIdNull() && 
+                        j.ParentJobId == job.Id
+                 select j;
+            });
       }
 
       return null;
-    }
-
-    public ICollection<Job> GetAllJobs() {
-      IList<Job> allJobs =
-        new List<Job>();
-
-      foreach (dsHiveServer.JobRow row in data) {
-        Job job = new Job();
-        Convert(row, job);
-        allJobs.Add(job);
-      }
-
-      return allJobs;
-    }
-
-    public ICollection<Job> GetAllSubjobs(Job job) {
-      IList<Job> allJobs =
-        new List<Job>();
-
-      if (job != null) {
-        IEnumerable<dsHiveServer.JobRow> clientJobs =
-         from j in
-           data.AsEnumerable<dsHiveServer.JobRow>()
-         where j.ParentJobId == job.JobId
-         select j;
-
-        foreach (dsHiveServer.JobRow row in
-          clientJobs) {
-          Job j = new Job();
-          Convert(row, j);
-          allJobs.Add(j);
-        }
-      }
-
-      return allJobs;
     }
 
@@ -189,67 +192,40 @@
 
     public ICollection<Job> GetJobsOf(ClientInfo client) {
-      IList<Job> allJobs =
-        new List<Job>();
-
       if (client != null) {
-        IEnumerable<dsHiveServer.JobRow> clientJobs =
-         from job in
-           data.AsEnumerable<dsHiveServer.JobRow>()
-         where !job.IsResourceIdNull() && 
-          job.ResourceId == client.ResourceId
-         select job;
-
-        foreach (dsHiveServer.JobRow row in
-          clientJobs) {
-          Job job = new Job();
-          Convert(row, job);
-          allJobs.Add(job);
-        }
-      }
-
-      return allJobs;
+        return
+          base.FindMultiple(
+            delegate() {
+              return adapter.GetDataByClient(client.Id);
+            },
+            delegate() {
+              return from job in
+                 cache.AsEnumerable<dsHiveServer.JobRow>()
+               where !job.IsResourceIdNull() && 
+                      job.ResourceId == client.Id
+               select job;
+            });
+      }
+
+      return null;
     }
 
     public ICollection<Job> GetJobsOf(User user) {
-      IList<Job> allJobs =
-        new List<Job>();
-
       if (user != null) {
-        IEnumerable<dsHiveServer.JobRow> userJobs =
-        from job in
-          data.AsEnumerable<dsHiveServer.JobRow>()
-        where
-          !job.IsPermissionOwnerIdNull() &&
-          job.PermissionOwnerId == user.PermissionOwnerId
-        select job;
-
-        foreach (dsHiveServer.JobRow row in
-          userJobs) {
-          Job job = new Job();
-          Convert(row, job);
-          allJobs.Add(job);
-        }
-      }
-
-      return allJobs;
-    }
-
-    [MethodImpl(MethodImplOptions.Synchronized)]
-    public bool DeleteJob(Job job) {
-      if (job != null) {
-        dsHiveServer.JobRow row =
-          data.FindByJobId(job.JobId);
-
-        if (row != null) {
-          row.Delete();
-          adapter.Update(row);
-
-          return true;
-        }
-      }
-
-      return false;
-    }
-
+        return 
+          base.FindMultiple(
+            delegate() {
+              return adapter.GetDataByUser(user.Id);
+            },
+            delegate() {
+              return from job in
+                cache.AsEnumerable<dsHiveServer.JobRow>()
+              where !job.IsPermissionOwnerIdNull() &&
+                job.PermissionOwnerId == user.Id
+              select job;
+            });
+      }
+
+      return null;
+    }
     #endregion
   }
